#include <nds.h>
#include <libfb\libcommon.h>
#include <string.h>
#include <stdio.h>

#include "bgTemp_bin.h"
#include "sprites.h"
#include "font_kartika_14.h"

void waitForTouch()
{
	uint16 specialKeysPressed = ~IPC->buttons;
	
	while((specialKeysPressed & (1 << 6)))  // display splash until the touchpad is tapped
	{	
		specialKeysPressed = ~IPC->buttons;
		swiWaitForVBlank();
	}	
	
	while(!(specialKeysPressed & (1 << 6)))  // display splash until the touchpad is tapped
	{	
		specialKeysPressed = ~IPC->buttons;
		swiWaitForVBlank();
	}	
}

int main()
{
    powerON(POWER_ALL_2D);

    irqSet(IRQ_VBLANK, 0);
	irqEnable(IRQ_VBLANK);	
			
	fb_init();	
	bg_init();
	setFont((uint16 **)font_kartika_14);
	fb_setBG((uint16 *)bgTemp_bin);
	swiWaitForVBlank();
	fb_swapBuffers();
	
	waitForTouch();
	
	setColor(RGB15(0,31,0));
	fb_dispAnimatedBox(20, 20, 160, 59, 5,5, "Sample!!\nWordwrap, tabstops, clipping, etc...");	
	fb_dispSprite(20+140, 20+10, smileySPrite, 0);
	swiWaitForVBlank();
	fb_swapBuffers();
	
	waitForTouch();
	
	fb_setDialogBox(20, 20, 160, 59);
	setColor(RGB15(0,31,0));
	fb_dispString(5, 5, "Sample!!\nWordwrap, tabstops, clipping, etc...");	
	fb_dispSprite(20+140, 20+10, smileySPrite, 0);
	
	setColor(RGB15(0,0,31));
	fb_dispAnimatedBox(75, 20+60+20, 170, 33, 5, 5, "Multiple windows too!");
	swiWaitForVBlank();
	fb_swapBuffers();
	
	waitForTouch();
	
	fb_setDialogBox(25, 40, 160, 59);
	setColor(RGB15(31,31,0));
	fb_dispString(5,5, "Doesn't have to be animated, either. Normal display works too!");	
	
	fb_setDefaultClipping();
	setColor(RGB15(31,0,0));
	fb_dispString(10, 125, "It can be on the background too! You don't need boxes...");
	fb_swapBuffers();
	
	waitForTouch();
	
	fb_setDialogBox(25, 40, 160, 59);
	setColor(RGB15(31,31,0));
	fb_dispString(5,5, "Doesn't have to be animated, either. Normal display works too!");	
	
	fb_setDefaultClipping();
	
	char str[100];
	sprintf(str, "It can be on the background too! You don't need boxes...\n\nAnd graphics for the buttons too...%c %c %c", BUTTON_A, BUTTON_L, BUTTON_UP);
	setColor(RGB15(31,0,0));
	fb_dispString(10, 125, str);
	
	fb_swapBuffers();
	
	waitForTouch();
	
	fb_eraseBG();
	fb_swapBuffers();
	setColor(0xFFFF);
	fb_dispString(5,5, "This was displayed using double buffering and includes custom any size sprite routines, as well as wordwrapped varible width font with tab stop support.\n\nProgrammed by DragonMinded\n\nFirst NDS example!");
	fb_swapBuffers();
	setColor(0xFFFF);
	bg_dispString(5,5, "This example also shows the use of an extended background buffer to enable scrolling with this library.");
	bg_swapBuffers();
	
	//main loop
	
	while(1)
	{	
		swiWaitForVBlank();
	}
}
